"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactSelect = _interopRequireDefault(require("react-select"));

var _chromaJs = _interopRequireDefault(require("chroma-js"));

require("../index.css");

require("./index.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

require('bootstrap/dist/js/bootstrap');

var ID = function ID() {
  // Math.random should be unique because of its seeding algorithm.
  // Convert it to base 36 (numbers + letters), and grab the first 9 characters
  // after the decimal.
  return '_' + Math.random().toString(36).substr(2, 9);
};

var getFilterOptions = function getFilterOptions(options, key) {
  return options[key].map(function (item) {
    return {
      value: ID(),
      label: item
    };
  });
};

var getFilterData = function getFilterData(filters) {
  var _ref;

  var filterList = filters.map(function (item) {
    return {
      prop: item.prop,
      options: item.value.map(function (val) {
        return val.label;
      })
    };
  });
  return (_ref = []).concat.apply(_ref, _toConsumableArray(filterList)).filter(function (elem, index, self) {
    return index === self.indexOf(elem);
  });
};

var DataTableFilter =
/*#__PURE__*/
function (_Component) {
  _inherits(DataTableFilter, _Component);

  function DataTableFilter(props) {
    var _this;

    _classCallCheck(this, DataTableFilter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DataTableFilter).call(this, props));
    _this.toggleFilter = _this.toggleFilter.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.addFilter = _this.addFilter.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.removeFilter = _this.removeFilter.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onFilterChange = _this.onFilterChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onMenuOpen = _this.onMenuOpen.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.state = {
      filters: [],
      toggleFilter: true,
      currentFilter: 0
    };
    return _this;
  }

  _createClass(DataTableFilter, [{
    key: "addFilter",
    value: function addFilter() {
      var keys = this.props.keys;

      var filters = _toConsumableArray(this.state.filters);

      filters.push({
        prop: keys[0].prop,
        value: [],
        options: getFilterOptions(this.props.options, keys[0].prop)
      });
      this.setState({
        filters: filters
      });
    }
  }, {
    key: "onMenuOpen",
    value: function onMenuOpen(index) {
      this.setState(function (prevState) {
        return _objectSpread({}, prevState, {
          currentFilter: index
        });
      });
    }
  }, {
    key: "changeFilterProp",
    value: function changeFilterProp(e, index) {
      var _this2 = this;

      var filters = _toConsumableArray(this.state.filters);

      filters[index] = _objectSpread({}, filters[index], {
        prop: e.target.value,
        options: getFilterOptions(this.props.options, e.target.value)
      });
      this.setState({
        filters: filters
      }, function () {
        var f = getFilterData(filters);

        _this2.props.changeFilter(f);
      });
    }
  }, {
    key: "removeFilter",
    value: function removeFilter(i) {
      var _this3 = this;

      var filters = _toConsumableArray(this.state.filters);

      filters.splice(i, 1);
      this.setState({
        filters: filters
      }, function () {
        var f = getFilterData(filters);

        _this3.props.changeFilter(f);
      });
    }
  }, {
    key: "toggleFilter",
    value: function toggleFilter() {
      this.setState(function (prevState) {
        return {
          toggleFilter: prevState.toggleFilter
        };
      });
    }
  }, {
    key: "onFilterChange",
    value: function onFilterChange(value) {
      var _this4 = this;

      var filters = _toConsumableArray(this.state.filters);

      filters[this.state.currentFilter].value = value;
      this.setState({
        filters: filters
      }, function () {
        var f = getFilterData(filters);

        _this4.props.changeFilter(f);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var _this$props = this.props,
          baseColor = _this$props.baseColor,
          keys = _this$props.keys;
      var customStyles = {
        control: function control(styles, state) {
          return _objectSpread({}, styles, {
            maxWidth: 230,
            boxShadow: "none",
            borderColor: state.isFocused ? baseColor : '#ced4da',
            '&:hover': {
              borderColor: baseColor
            }
          });
        },
        option: function option(styles, _ref2) {
          var data = _ref2.data,
              isDisabled = _ref2.isDisabled,
              isFocused = _ref2.isFocused,
              isSelected = _ref2.isSelected;
          var color = (0, _chromaJs.default)(baseColor);
          return _objectSpread({}, styles, {
            backgroundColor: isDisabled ? null : isSelected ? baseColor : isFocused ? color.alpha(0.1).css() : null,
            color: isDisabled ? '#ccc' : isSelected ? _chromaJs.default.contrast(color, 'white') > 2 ? 'white' : 'black' : '#333',
            cursor: isDisabled ? 'not-allowed' : 'default'
          });
        }
      };
      console.log(this.state.filters);
      return _react.default.createElement("div", {
        className: "dt-filter"
      }, this.state.toggleFilter ? _react.default.createElement("div", {
        className: "dt-row-filter-content d-flex flex-column"
      }, this.state.filters.map(function (filter, index) {
        return _react.default.createElement("div", {
          key: "option_".concat(index),
          className: "dt-row-filter-row d-flex align-items-start justify-content-center flex-grow-1 mb-1"
        }, _react.default.createElement("button", {
          type: "button",
          className: "btn btn-light btn-sm",
          onClick: function onClick() {
            return _this5.removeFilter(index);
          }
        }, _react.default.createElement("i", {
          className: "fa fa-times"
        })), _react.default.createElement("select", {
          onChange: function onChange(e) {
            return _this5.changeFilterProp(e, index);
          },
          value: filter.prop,
          className: "custom-select dt-custom-select ml-1 mr-1"
        }, keys.map(function (item, i) {
          return _react.default.createElement("option", {
            key: "option_".concat(i),
            value: item.prop
          }, item.title);
        })), _react.default.createElement(_reactSelect.default, {
          value: filter.value,
          closeMenuOnSelect: false,
          isMulti: true,
          onChange: _this5.onFilterChange,
          onMenuOpen: function onMenuOpen() {
            return _this5.onMenuOpen(index);
          },
          options: filter.options,
          styles: customStyles,
          className: "dt-row-filter-select flex-grow-1",
          classNamePrefix: "dt-filter"
        }));
      }), _react.default.createElement("button", {
        type: "button",
        className: "btn btn-light btn-sm",
        onClick: function onClick() {
          return _this5.addFilter();
        }
      }, _react.default.createElement("i", {
        className: "fa fa-plus"
      }), " Add filter")) : '');
    }
  }]);

  return DataTableFilter;
}(_react.Component);

var _default = DataTableFilter;
exports.default = _default;