"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _server = _interopRequireDefault(require("react-dom/server"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash"));

var _moment = _interopRequireDefault(require("moment"));

var _index = _interopRequireDefault(require("./loader/index"));

var _index2 = _interopRequireDefault(require("./filter/index"));

require("./index.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var EventEmitter = require('eventemitter3');

var EventEmitterClient =
/*#__PURE__*/
function () {
  function EventEmitterClient() {
    _classCallCheck(this, EventEmitterClient);

    this.eventEmitter = new EventEmitter();
  }

  _createClass(EventEmitterClient, [{
    key: "on",
    value: function on(eventName, listener) {
      this.eventEmitter.on(eventName, listener);
    }
  }, {
    key: "removeEventListener",
    value: function removeEventListener(eventName, listener) {
      this.eventEmitter.removeListener(eventName, listener);
    }
  }, {
    key: "emit",
    value: function emit(event, payload) {
      var error = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      this.eventEmitter.emit(event, payload, error);
    }
  }, {
    key: "getEventEmitter",
    value: function getEventEmitter() {
      return this.eventEmitter;
    }
  }]);

  return EventEmitterClient;
}();

var eeclient = new EventEmitterClient();

var $ = require('jquery');

window.jQuery = require('jquery');

require('bootstrap/dist/js/bootstrap');

require('datatables.net');

require('datatables.net-colreorder');

require('datatables.net-fixedcolumns');

require('datatables.net-buttons');

require('datatables.net-buttons/js/buttons.colVis.min');

require('datatables.net-buttons/js/buttons.html5.min');

require('datatables.net-select');

require('./editor/dataTables.editor');

var DEFAULT_STRING_CONTENT = 'N/A';
var DEFAULT_NUM_CONTENT = 0;
var DEFAULT_NUM_DATE_CONTENT = 'Never';
var DEFAULT_HTML_CONTENT = '<span></span>';
var DEFAULT_NUM_FMT_CONTENT = 0;
var DEFAULT_HTML_NUM_CONTENT = 0;
var DEFAULT_HTML_NUM_FMT_CONTENT = 0;
var DEFAULT_DATE_CONTENT = 0;
var TYPES_LIST = ['num', 'date', 'num-fmt', 'html-num', 'html-num-fmt', 'html', 'string', 'num-date'];
var DEFAULT_TARGET_ID = 'dt-data-table-container';
var DEFAULT_COLOR = '#1ab394';
var DEFAULT_TOOLTIP_COLOR = '#293846';
var DT_ROW_CHECKBOX = 'dtRowCheckbox';
var DT_ROW_ACTION = 'dtRowAction';
var BULK_ACTION_COLUMN = [{
  prop: DT_ROW_CHECKBOX,
  className: 'dt-select-checkbox no-colvis'
}];
var ROW_ACTION_COLUMN = [{
  prop: DT_ROW_ACTION,
  className: 'dt-action-dropdown no-colvis'
}];

var isEmpty = function isEmpty(value) {
  return value == null || value === '';
};

var isEmptyObject = function isEmptyObject(obj) {
  return !obj ? true : Object.keys(obj).length === 0 && obj.constructor === Object;
};

var isEmptyArray = function isEmptyArray(value) {
  return !Array.isArray(value) || Array.isArray(value) && !value.length;
};

var isColEditable = function isColEditable(col) {
  return col.hasOwnProperty('editable') && col.editable;
};

var isColClickable = function isColClickable(col) {
  return col.hasOwnProperty('clickable') && col.clickable;
};

var colHasProp = function colHasProp(col, prop) {
  return col.hasOwnProperty(prop);
};

var getNotHiddenCols = function getNotHiddenCols(columns) {
  return columns.filter(function (col) {
    return !col.hasOwnProperty('hidden') || col.hasOwnProperty('hidden') && !col.hidden;
  });
};

var getCols = function getCols(bulkActions, rowActions, columns) {
  return (!isEmptyObject(bulkActions) ? BULK_ACTION_COLUMN : []).concat(columns.filter(function (col) {
    return !col.hasOwnProperty('hidden') || !col.hidden;
  })).concat(!isEmptyObject(rowActions) ? ROW_ACTION_COLUMN : []);
};

var changeElColor = function changeElColor(first, second, color) {
  first.find('.dt-button-text')[0].style.backgroundColor = color;
  second.find('.dt-button-text')[0].style.backgroundColor = '';
};

var generateKey = function generateKey(pre) {
  return "".concat(pre, "_").concat(new Date().getTime());
};

var generateUniuqeId = function generateUniuqeId(pre) {
  return "".concat(pre || '', "_").concat(Math.random().toString(36).substr(2, 9));
};

var getColumnsOrder = function getColumnsOrder(columns, hasBulkActions, defaultOrder) {
  if (!isEmptyArray(defaultOrder)) {
    var availableIdxs = columns.filter(function (col) {
      return !colHasProp(col, 'hidden') || !col.hidden;
    }).map(function (col, idx) {
      return !colHasProp(col, 'visible') || col.visible ? hasBulkActions ? idx + 1 : idx : '';
    }).filter(function (col) {
      return col !== '';
    });
    var colIdx = defaultOrder[0],
        colOrder = defaultOrder[1];
    var colNewIdx = availableIdxs.includes(colIdx) ? hasBulkActions ? colIdx + 1 : colIdx : availableIdxs[0];
    return [[colNewIdx, colOrder]];
  }

  var idx = columns.filter(function (col) {
    return !colHasProp(col, 'hidden') || !col.hidden;
  }).findIndex(function (col) {
    return !colHasProp(col, 'visible') || col.visible;
  });
  return [hasBulkActions ? idx + 1 : idx, "asc"];
};

var getCellValue = function getCellValue(_ref, row) {
  var prop = _ref.prop,
      render = _ref.render;

  if (!isEmpty(prop) && isEmpty(row[prop])) {
    return '';
  } else if (render) {
    return render(row[prop], row);
  } else {
    return row[prop];
  }
};

var getFilterOptions = function getFilterOptions(keys, data) {
  var options = {};
  keys.map(function (key) {
    return options[key.prop] = data.map(function (d) {
      return d[key.prop] || getDefaultContent(key);
    }).filter(function (d) {
      return d;
    });
  });
  return options;
};

var getEditableFields = function getEditableFields(columns) {
  return columns.filter(function (col) {
    return colHasProp(col, 'editable') && col.editable;
  }).map(function (col) {
    return {
      name: col.prop
    };
  });
};

var findOneEl = function findOneEl(searchData, row, columns) {
  var arr = [];
  var haystack = [];
  searchData.map(function (data) {
    var options = data.options,
        prop = data.prop;
    arr = arr.concat(options);
    haystack = haystack.concat(Object.entries(row).map(function (d) {
      var key = d[0];
      var value = d[1];

      if (key === prop) {
        var col = columns.find(function (col) {
          return col.prop === prop;
        });
        return row[key] || getDefaultContent(col);
      }

      return value;
    }));
  });

  if (!arr.length) {
    return true;
  } else {
    return arr.every(function (v) {
      return haystack.indexOf(v) >= 0;
    });
  }
};

var parseStrToNum = function parseStrToNum(str) {
  if (!str) {
    return -1;
  }

  var values = str.split(" ");
  var date = (0, _moment.default)(0);
  values.forEach(function (val, i) {
    if (i % 2 !== 0) {
      return;
    }

    date.add(+val.trim(), values[i + 1]);
  });
  return +date.toDate();
};

var getDefaultContent = function getDefaultContent(col) {
  var _col$type = col.type,
      type = _col$type === void 0 ? 'string' : _col$type,
      defaultContent = col.defaultContent;

  var valType = _typeof(defaultContent);

  switch (type) {
    case 'string':
      return !valType ? DEFAULT_STRING_CONTENT : valType === 'string' ? defaultContent : DEFAULT_STRING_CONTENT;

    case 'num':
      return !valType ? DEFAULT_NUM_CONTENT : valType === 'number' ? defaultContent : DEFAULT_NUM_CONTENT;

    case 'date':
      return !valType ? DEFAULT_DATE_CONTENT : valType === 'number' ? defaultContent : DEFAULT_DATE_CONTENT;

    case 'num-fmt':
      return !valType ? DEFAULT_NUM_FMT_CONTENT : valType === 'number' ? defaultContent : DEFAULT_NUM_FMT_CONTENT;

    case 'html-num':
      return !valType ? DEFAULT_HTML_NUM_CONTENT : valType === 'number' ? defaultContent : DEFAULT_HTML_NUM_CONTENT;

    case 'html-num-fmt':
      return !valType ? DEFAULT_HTML_NUM_FMT_CONTENT : valType === 'number' ? defaultContent : DEFAULT_HTML_NUM_FMT_CONTENT;

    case 'num-date':
      return !valType ? DEFAULT_NUM_DATE_CONTENT : valType === 'string' ? defaultContent : DEFAULT_NUM_DATE_CONTENT;

    case 'html':
      return !valType ? DEFAULT_HTML_CONTENT : valType === 'string' ? defaultContent : DEFAULT_HTML_CONTENT;
  }
};

var DataTable =
/*#__PURE__*/
function (_Component) {
  _inherits(DataTable, _Component);

  function DataTable(props) {
    var _this;

    _classCallCheck(this, DataTable);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DataTable).call(this, props));
    _this.postRender = _this.postRender.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.getDTMarkup = _this.getDTMarkup.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.changeFilter = _this.changeFilter.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.showRowFilter = _this.showRowFilter.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleClickOutsideFilter = _this.handleClickOutsideFilter.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.getTableColumn = _this.getTableColumn.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(DataTable, [{
    key: "handleClickOutsideFilter",
    value: function handleClickOutsideFilter(event) {
      if (_reactDom.default.findDOMNode(this.refs.dtDataTableFilter) && !_reactDom.default.findDOMNode(this.refs.dtDataTableFilter).contains(event.target)) {
        _reactDom.default.findDOMNode(this.refs.dtDataTableFilter).style.display = 'none';
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.postRender();
      _reactDom.default.findDOMNode(this.refs.dtDataTableFilter).style.display = 'none';
      document.addEventListener('mousedown', this.handleClickOutsideFilter);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.postRender();
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      // show loader if datatable is reloading
      _reactDom.default.findDOMNode(this.refs.dtDataTableLoader).style.display = nextProps.loading ? 'block' : 'none'; // check if dataArray changes, if so implement componentDidMount code in componentDidUpdate

      var isEqualDataArray = _lodash.default.isEqual(this.props.dataArray, nextProps.dataArray);

      return !isEqualDataArray;
    }
  }, {
    key: "showRowFilter",
    value: function showRowFilter() {
      var display = _reactDom.default.findDOMNode(this.refs.dtDataTableFilter).style.display;

      if (display === 'block') {
        _reactDom.default.findDOMNode(this.refs.dtDataTableFilter).style.display = 'none';
      } else {
        _reactDom.default.findDOMNode(this.refs.dtDataTableFilter).style.display = 'block';
      }
    }
  }, {
    key: "changeFilter",
    value: function changeFilter(data) {
      eeclient.emit('TABLE_ROW_FILTER', data);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      eeclient.removeListener('TABLE_ROW_FILTER', function () {});
      document.removeEventListener('mousedown', this.handleClickOutsideFilter);
    }
  }, {
    key: "getTableColumn",
    value: function getTableColumn() {
      var _this$props = this.props,
          bulkActions = _this$props.bulkActions,
          rowActions = _this$props.rowActions,
          columns = _this$props.columns,
          options = _this$props.options,
          rowId = _this$props.rowId;

      var _ref2 = options || {},
          _ref2$baseColor = _ref2.baseColor,
          baseColor = _ref2$baseColor === void 0 ? DEFAULT_COLOR : _ref2$baseColor,
          _ref2$tooltipBaseColo = _ref2.tooltipBaseColor,
          tooltipBaseColor = _ref2$tooltipBaseColo === void 0 ? DEFAULT_TOOLTIP_COLOR : _ref2$tooltipBaseColo;

      var cols = getCols(bulkActions, rowActions, columns);
      return cols.map(function (col, idx) {
        if (col.prop === DT_ROW_CHECKBOX) {
          return {
            defaultContent: 'N/A',
            name: DT_ROW_CHECKBOX,
            orderable: false,
            searchable: false,
            visible: true,
            width: '42px',
            className: "select-checkbox ".concat(col.className),
            style: {
              color: baseColor
            },
            render: function render(data, type, row, meta) {
              var checkbox = $("<input/>", {
                "type": "checkbox"
              });
              return checkbox.prop("outerHTML");
            }
          };
        }

        if (col.prop === DT_ROW_ACTION) {
          return {
            defaultContent: 'N/A',
            name: DT_ROW_ACTION,
            orderable: false,
            searchable: false,
            visible: true,
            width: '42px',
            className: col.className,
            render: function render(data, type, row, meta) {
              var _id = row[rowId] || generateUniuqeId('rowaction');

              var dropId = "dropdown-".concat(col.prop, "-").concat(_id);
              return "<div class=\"dropdown dt-tooltip-container\">\n                                    <button class=\"dropdown-toggle\" type=\"button\" style=\"color: ".concat(baseColor, "\" id=\"").concat(dropId, "\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>\n                                    <span class=\"dt-tooltip\" style=\"background-color: ").concat(tooltipBaseColor, "\">Display actions\n                                        <span style=\"color: ").concat(tooltipBaseColor, "\" class=\"dt-tooltip-arrow\"></span>\n                                    </span>\n                                    <div class=\"dropdown-menu\" aria-labelledby=\"").concat(dropId, "\">\n                                        ").concat(Object.entries(rowActions).map(function (_ref3, idx) {
                var _ref4 = _slicedToArray(_ref3, 2),
                    key = _ref4[0],
                    action = _ref4[1];

                return "<div key=\"".concat(idx, "\" class=\"dropdown-item\" data-action-key=\"").concat(key, "\" data-action-id=\"").concat(_id, "\">").concat(action.title, "</div>");
              }).join(' '), "\n                                    </div>\n                                </div>");
            }
          };
        } else {
          var defVal = getDefaultContent(col);
          return {
            name: col.prop,
            type: col.type,
            defaultContent: defVal,
            searchable: colHasProp(col, 'searchable') ? col.searchable : true,
            visible: colHasProp(col, 'visible') ? col.visible : true,
            data: col.prop,
            className: "".concat(col.className || '', " ").concat(isColEditable(col) ? 'dt-edit-action' : '', " ").concat(isColClickable(col) ? 'dt-click-action' : ''),
            render: function render(data, type, row, meta) {
              var _id = row[rowId] || generateUniuqeId('dtdata');

              if (type === 'display') {
                return "<span class=\"dt-data\" data-action-key=".concat(col.prop, " data-action-id=").concat(_id, ">").concat(getCellValue(col, row) || defVal, "</span>\n                                        ").concat(isColEditable(col) ? '<i class="fa fa-edit"/>' : '<i class="fa fa-lock"/>');
              }

              return data;
            }
          };
        }
      }); //to do
      // if (initialPageLength && initialPageLength <= index) {
      //     return null;
      // }
    }
  }, {
    key: "postRender",
    value: function postRender() {
      var targetId = this.props.targetId || DEFAULT_TARGET_ID;
      $("#".concat(targetId)).empty();
      var table = this.getDTMarkup();
      var container = this.refs.dtDataTableDiv;

      var renderedTable = _server.default.renderToStaticMarkup(table, container);

      $("#".concat(targetId)).append(renderedTable);
      var jqueryTable = $("#".concat(targetId, " table"));

      var _ref5 = this.props.options || {},
          doNotAllowSearch = _ref5.doNotAllowSearch,
          doNotAllowInfo = _ref5.doNotAllowInfo,
          doNotAllowPage = _ref5.doNotAllowPage,
          doNotAllowExport = _ref5.doNotAllowExport,
          doNotAllowColvis = _ref5.doNotAllowColvis,
          doNotAllowFilter = _ref5.doNotAllowFilter,
          quickFilter = _ref5.quickFilter,
          sortBy = _ref5.sortBy,
          _ref5$baseColor = _ref5.baseColor,
          baseColor = _ref5$baseColor === void 0 ? DEFAULT_COLOR : _ref5$baseColor,
          _ref5$tooltipBaseColo = _ref5.tooltipBaseColor,
          tooltipBaseColor = _ref5$tooltipBaseColo === void 0 ? DEFAULT_TOOLTIP_COLOR : _ref5$tooltipBaseColo;

      var _this$props2 = this.props,
          rowActions = _this$props2.rowActions,
          bulkActions = _this$props2.bulkActions,
          columns = _this$props2.columns,
          clickHandler = _this$props2.clickHandler,
          rowId = _this$props2.rowId,
          dataArray = _this$props2.dataArray,
          editorSaveHandler = _this$props2.editorSaveHandler;
      var showRowFilter = this.showRowFilter;
      var tableDomElement = "<\"dt-data-table-header d-flex align-items-center\"<\"buttons flex-grow-1\"B>".concat(!doNotAllowSearch ? '<"search"f>' : '', "><\"dt-data-table-body\"tr><\"dt-data-table-footer d-flex\"").concat(!doNotAllowInfo ? '<"info d-flex align-items-center flex-grow-1"li>' : '').concat(!doNotAllowPage ? '<"page"p>' : '', ">");
      var rightColReorder = !isEmptyObject(rowActions) ? {
        fixedColumnsRight: 1
      } : {};
      var leftColReorder = !isEmptyObject(bulkActions) ? {
        fixedColumnsLeft: 1
      } : {};
      var leftColFixed = !isEmptyObject(bulkActions) ? {
        leftColumns: 1
      } : {
        leftColumns: 0
      };
      var rightColFixed = !isEmptyObject(rowActions) ? {
        rightColumns: 1
      } : {
        rightColumns: 0
      };
      var order = getColumnsOrder(columns, !isEmptyObject(bulkActions), sortBy);
      var bulkActionsButton = isEmptyObject(bulkActions) ? [] : [{
        text: "<span class=\"dt-tooltip\" style=\"background-color: ".concat(tooltipBaseColor, "\" disabled>Bulk actions \n                    <span style=\"color: ").concat(tooltipBaseColor, "\" class=\"dt-tooltip-arrow\" /></span>\n                   <div class=\"dropdown\">\n                      <button id = \"bulkActionsButton\" data-toggle = \"dropdown\" disabled><i class = \"fa fa-list\"/></button>\n                      <div class=\"dropdown-menu\" aria-labelledby=\"bulkActionsButton\">\n                            ").concat(Object.entries(bulkActions).map(function (_ref6, idx) {
          var _ref7 = _slicedToArray(_ref6, 2),
              key = _ref7[0],
              action = _ref7[1];

          return "<div key=".concat(generateKey("div-".concat(idx)), " \n                                        class=\"dropdown-item\" \n                                        data-action-key=").concat(key, ">").concat(action.title, "</div>");
        }).join(' '), "\n                      </div>\n                   </div>"),
        className: 'dt-tooltip-container dt-bulk-actions'
      }];

      var _ref8 = quickFilter || {},
          allow = _ref8.allow,
          condition = _ref8.condition;

      var _ref9 = condition || {},
          key = _ref9.key,
          value = _ref9.value;

      var quickFilterButton = !allow ? [] : [{
        text: "<span class=\"dt-button-text\">All</span>\n                        <span class=\"dt-tooltip\" style=\"background-color: ".concat(tooltipBaseColor, "\">Show all items\n                        <span style=\"color: ").concat(tooltipBaseColor, "\" class=\"dt-tooltip-arrow\" />\n                   </span>"),
        className: 'dt-tooltip-container dt-quick-filter dt-all-quick-filter'
      }, {
        text: "<span class=\"dt-button-text\">My</span>\n                        <span class=\"dt-tooltip\" style=\"background-color: ".concat(tooltipBaseColor, "\">Show my items\n                        <span style=\"color: ").concat(tooltipBaseColor, "\" class=\"dt-tooltip-arrow\" />\n                   </span>"),
        className: 'dt-tooltip-container dt-quick-filter dt-my-quick-filter'
      }];
      var colvisButtons = doNotAllowColvis ? [] : [{
        extend: 'colvis',
        columns: ':not(.no-colvis)',
        className: 'dt-colvis dt-tooltip-container',
        text: "<span class=\"dt-tooltip\" style=\"background-color: ".concat(tooltipBaseColor, "\">Edit columns\n                        <span style=\"color: ").concat(tooltipBaseColor, "\" class=\"dt-tooltip-arrow\" />\n                    </span>\n                    <i class=\"fa fa-cogs\" style=\"color: ").concat(baseColor, "\"/>")
      }];
      var csvButtons = doNotAllowExport ? [] : [{
        extend: 'csvHtml5',
        text: "<span class=\"dt-tooltip\" style=\"background-color: ".concat(tooltipBaseColor, "\">Export to CSV\n                        <span style=\"color: ").concat(tooltipBaseColor, "\" class=\"dt-tooltip-arrow\" />\n                  </span>\n                  <i class=\"fa fa-download\" style=\"color: ").concat(baseColor, "\">"),
        exportOptions: {
          columns: ':not(.no-colvis)'
        },
        className: 'dt-tooltip-container dt-button-csv',
        filename: function filename() {
          return "*".concat(new Date(), ".csv");
        },
        header: false
      }];
      var rowFilterButton = doNotAllowFilter ? [] : [{
        text: "<span class=\"dt-tooltip\" style=\"background-color: ".concat(tooltipBaseColor, "\">Filter list\n                        <span style=\"color: ").concat(tooltipBaseColor, "\" class=\"dt-tooltip-arrow\" />\n                  </span>\n                  <i class=\"fa fa-filter\" style=\"color: ").concat(baseColor, "\">"),
        className: 'dt-tooltip-container dt-row-filter'
      }];
      var buttons = [].concat(bulkActionsButton, colvisButtons, rowFilterButton, csvButtons, quickFilterButton);
      var select = isEmptyObject(bulkActions) ? {} : {
        style: 'multi',
        selector: 'td.dt-select-checkbox'
      };

      $.fn.dataTableExt.oSort['num-date-asc'] = function (a, b) {
        var c = parseStrToNum(a);
        var d = parseStrToNum(b);
        return c < d ? -1 : c > d ? 1 : 0;
      };

      $.fn.dataTableExt.oSort['num-date-desc'] = function (a, b) {
        var c = parseStrToNum(a);
        var d = parseStrToNum(b);
        return c < d ? 1 : c > d ? -1 : 0;
      };

      jqueryTable.DataTable({
        dom: tableDomElement,
        columns: this.getTableColumn(),
        data: dataArray,
        pagingType: 'full_numbers',
        language: {
          lengthMenu: '_MENU_',
          info: 'Showing page _PAGE_ of _PAGES_',
          infoEmpty: 'No records available',
          infoFiltered: ' ',
          search: ' ',
          searchPlaceholder: 'Search'
        },
        responsive: true,
        colReorder: _objectSpread({}, leftColReorder, rightColReorder, {
          realtime: false
        }),
        scrollX: true,
        fixedColumns: _objectSpread({}, leftColFixed, rightColFixed),
        rowId: rowId,
        order: order,
        createdRow: function createdRow(row, data, dataIndex, cells) {
          $(row).addClass('dt-row-tr');
          $(row).find('td.dt-click-action').css('color', baseColor);
          $(row).find('td.dt-select-checkbox').css('color', baseColor);
        },
        initComplete: function initComplete() {
          var table = this.api();
          var quickFilterAll = $(this.api().button('.dt-quick-filter.dt-all-quick-filter').node());
          var quickFilterMy = $(this.api().button('.dt-quick-filter.dt-my-quick-filter').node());

          if (quickFilterAll.length && quickFilterMy.length) {
            if (!$.fn.dataTable.ext.afnQuickFilter || $.fn.dataTable.ext.afnQuickFilter && $.fn.dataTable.ext.afnQuickFilter === 'all') {
              changeElColor(quickFilterAll, quickFilterMy, baseColor);
            } else {
              changeElColor(quickFilterMy, quickFilterAll, baseColor);
            }

            quickFilterAll.click(function () {
              $.fn.dataTable.ext.afnQuickFilter = 'all';
              $.fn.dataTable.ext.search.pop();
              table.draw();
              changeElColor(quickFilterAll, quickFilterMy, baseColor);
            });
            quickFilterMy.click(function () {
              $.fn.dataTable.ext.afnQuickFilter = 'my';
              $.fn.dataTable.ext.search.push(function (settings, searchData, index) {
                var rowd = dataArray[index];

                if (rowd[key] && rowd[key] === value) {
                  return true;
                }
              });
              table.draw();
              $.fn.dataTable.ext.search.pop();
              changeElColor(quickFilterMy, quickFilterAll, baseColor);
            });
            this.on('search.dt', function () {
              $.fn.dataTable.ext.afnQuickFilter = 'all';
              changeElColor(quickFilterAll, quickFilterMy, baseColor);
            });
            this.on('order.dt', function () {
              $.fn.dataTable.ext.afnQuickFilter = 'all';
              changeElColor(quickFilterAll, quickFilterMy, baseColor);
            });
          }

          var headerCheckbox = $($('table thead th.dt-select-checkbox.select-checkbox')[0]);
          headerCheckbox && headerCheckbox.on('click', 'span', function () {
            if (headerCheckbox.hasClass('selected')) {
              table.rows().deselect();
              headerCheckbox.removeClass('selected');
            } else {
              table.rows().select();
              headerCheckbox.addClass('selected');
            }
          });
          var bulkActionBtn = $(this.api().button('.dt-bulk-actions').node()).find('.dropdown button')[0];
          var bulkActionBtnTooltip = $(this.api().button('.dt-bulk-actions').node()).find('.dt-tooltip')[0];
          table.on('select deselect', function () {
            if (table.rows({
              selected: true
            }).count() !== table.rows().count()) {
              headerCheckbox.removeClass('selected');
              $(bulkActionBtnTooltip).attr('disabled', true);
              bulkActionBtn.disabled = true;
            } else {
              headerCheckbox.addClass('selected');
              $(bulkActionBtnTooltip).attr('disabled', false);
              bulkActionBtn.disabled = false;
            }

            if (!table.rows({
              selected: true
            }).count()) {
              //All rows are deselected
              bulkActionBtn.style.color = '#bdbebf';
              $(bulkActionBtnTooltip).attr('disabled', true);
              bulkActionBtn.disabled = true;
            } else {
              bulkActionBtn.style.color = baseColor;
              $(bulkActionBtnTooltip).attr('disabled', false);
              bulkActionBtn.disabled = false;
            }
          });
          var bulkActionButtons = $(this.api().button('.dt-bulk-actions').node()).find('div.dropdown div.dropdown-menu .dropdown-item');
          Array.prototype.forEach.call(bulkActionButtons, function (item) {
            var dom = $(item);
            var key = dom[0].attributes['data-action-key'].value;
            return dom.click(function (ev) {
              ev.preventDefault();
              var ids = table.rows('.selected')[0].map(function (item) {
                return dataArray[item][rowId];
              });
              bulkActions[key].action(ids);
            });
          });

          if (clickHandler && typeof clickHandler === 'function') {
            this.api().cells('.dt-click-action').every(function () {
              var cell = this;
              var node = $(cell.node());
              var nodeData = node.find('span.dt-data');
              var id = nodeData[0].getAttribute('data-action-id');
              var key = nodeData[0].getAttribute('data-action-key');
              return nodeData.click(function (ev) {
                ev.preventDefault();
                clickHandler({
                  id: id,
                  key: key
                });
              });
            });
          }

          if (!isEmptyObject(rowActions)) {
            this.api().cells('.dt-action-dropdown').every(function () {
              var cell = this;
              var item = $(cell.node()).find('div.dropdown div.dropdown-menu .dropdown-item');
              var id = item[0].attributes['data-action-id'].value;
              var key = item[0].attributes['data-action-key'].value;
              return item.click(function (ev) {
                ev.preventDefault();
                rowActions[key].action(id);
              });
            });
          }

          eeclient.on('TABLE_ROW_FILTER', function (data) {
            if (!data || data && !data.length) {
              $.fn.dataTable.ext.search.pop();
              table.draw();
            } else {
              $.fn.dataTable.ext.search.push(function (settings, searchData, index, row) {
                if (findOneEl(data, row, columns)) {
                  return true;
                }
              });
              table.draw();
              $.fn.dataTable.ext.search.pop();
            }
          });
          var rowFilterBtn = $(this.api().button('.dt-row-filter').node());
          rowFilterBtn.click(function (e) {
            e.stopPropagation();
            showRowFilter();
          });
          var fields = getEditableFields(columns);

          if (fields.length) {
            var editor = new $.fn.dataTable.Editor({
              table: "#".concat(targetId, " #dt-table"),
              idSrc: rowId,
              fields: fields,
              ajax: function ajax(method, url, d, successCallback, errorCallback) {
                var output = {
                  data: []
                };

                if (d.action === 'edit') {
                  // Update each edited item with the data submitted
                  $.each(d.data, function (id, value) {
                    output.data.push(value);
                  });
                } // Show Editor what has changed


                successCallback(d.data);
              }
            });
            this.api().cells().every(function () {
              var cell = this;
              var node = $(cell.node()).find('i.fa-edit');
              return node.click(function (ev) {
                ev.preventDefault();
                editor.inline($(this).parent(), {
                  onReturn: function onReturn(param) {
                    param.submit(null, null, function (data) {
                      editorSaveHandler && editorSaveHandler({
                        obj: data
                      });
                    });
                  },
                  buttons: {
                    label: '&gt;',
                    submit: 'allIfChanged',
                    fn: function fn() {
                      this.submit(null, null, function (data) {
                        editorSaveHandler && editorSaveHandler({
                          obj: data
                        });
                      });
                    }
                  }
                });
              });
            });
          }
        },
        buttons: buttons,
        select: select
      });
    }
  }, {
    key: "getDTMarkup",
    value: function getDTMarkup() {
      var _this$props3 = this.props,
          columns = _this$props3.columns,
          options = _this$props3.options,
          bulkActions = _this$props3.bulkActions,
          rowActions = _this$props3.rowActions;
      var _options$baseColor = options.baseColor,
          baseColor = _options$baseColor === void 0 ? DEFAULT_COLOR : _options$baseColor;
      var cols = getCols(bulkActions, rowActions, columns);
      var headers = cols.map(function (col, idx) {
        return _react.default.createElement("th", {
          "data-class-name": col.prop,
          key: generateKey("th-".concat(idx)),
          className: col.className
        }, col.prop === DT_ROW_CHECKBOX ? _react.default.createElement("span", {
          className: "dt-select-all",
          style: {
            borderColor: baseColor,
            backgroundColor: baseColor
          }
        }) : col.prop === DT_ROW_ACTION ? '' : _react.default.createElement("span", {
          className: "dt-header-cell"
        }, col.title, _react.default.createElement("span", {
          className: "dt-sorting"
        })));
      });
      return _react.default.createElement("table", {
        id: "dt-table",
        className: "cell-border",
        width: "100%",
        cellSpacing: "0"
      }, _react.default.createElement("thead", null, _react.default.createElement("tr", {
        className: "dt-row-tr"
      }, headers)));
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var targetId = this.props.targetId || DEFAULT_TARGET_ID;
      var _this$props4 = this.props,
          loading = _this$props4.loading,
          columns = _this$props4.columns,
          dataArray = _this$props4.dataArray,
          _this$props4$options = _this$props4.options,
          options = _this$props4$options === void 0 ? {} : _this$props4$options;
      var _options$baseColor2 = options.baseColor,
          baseColor = _options$baseColor2 === void 0 ? DEFAULT_COLOR : _options$baseColor2;
      var keys = getNotHiddenCols(columns);
      return _react.default.createElement("div", {
        className: "dt-table-root position-relative"
      }, _react.default.createElement(_index.default, {
        ref: "dtDataTableLoader",
        baseColor: baseColor
      }), _react.default.createElement(_index2.default, {
        ref: "dtDataTableFilter",
        options: getFilterOptions(keys, dataArray),
        keys: keys,
        baseColor: baseColor,
        changeFilter: function changeFilter(d) {
          return _this2.changeFilter(d);
        }
      }), !loading ? _react.default.createElement("div", {
        ref: "dtDataTableDiv",
        id: targetId,
        className: "dt-data-table-container"
      }) : '');
    }
  }]);

  return DataTable;
}(_react.Component);

_defineProperty(DataTable, "propTypes", {
  loading: _propTypes.default.bool.isRequired,
  dataArray: _propTypes.default.array.isRequired,
  columns: _propTypes.default.arrayOf(_propTypes.default.shape({
    title: _propTypes.default.string.isRequired,
    prop: _propTypes.default.string.isRequired,
    render: _propTypes.default.func,
    sortable: _propTypes.default.bool,
    visibility: _propTypes.default.bool,
    type: _propTypes.default.oneOf(TYPES_LIST),
    defaultContent: _propTypes.default.string,
    width: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
    className: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func])
  })).isRequired,
  // the id of the div into which the table will render
  targetId: _propTypes.default.string,
  bulkActions: _propTypes.default.objectOf(_propTypes.default.shape({
    title: _propTypes.default.string.isRequired,
    action: _propTypes.default.func.isRequired
  })),
  rowActions: _propTypes.default.objectOf(_propTypes.default.shape({
    title: _propTypes.default.string.isRequired,
    action: _propTypes.default.func.isRequired
  })),
  clickHandler: _propTypes.default.func,
  editorSaveHandler: _propTypes.default.func,
  rowId: _propTypes.default.string,
  initialPageLength: _propTypes.default.number,
  options: _propTypes.default.shape({
    doNotAllowFilter: _propTypes.default.bool,
    doNotAllowSearch: _propTypes.default.bool,
    doNotAllowExport: _propTypes.default.bool,
    doNotAllowColvis: _propTypes.default.bool,
    quickFilter: _propTypes.default.shape({
      allow: _propTypes.default.bool,
      condition: _propTypes.default.shape({
        key: _propTypes.default.string.isRequired,
        value: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]).isRequired
      })
    }),
    doNotAllowInfo: _propTypes.default.bool,
    doNotAllowPage: _propTypes.default.bool,
    baseColor: _propTypes.default.string,
    tooltipBaseColor: _propTypes.default.string,
    sortBy: _propTypes.default.array
  })
});

var _default = DataTable;
exports.default = _default;